/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//機能名称 
//		  HACP プロトコルハンドラ
//変更履歴
//			  2003.11.24	zcj  新規作成		
//
package jp.co.ntt.lms.lo.scorm.cbtcom;

import java.util.NoSuchElementException;
//import java.util.StringTokenizer;

/**
 * HACP プロトコルハンドラ <BR>
 * @author zhaicj
 * 
 */
public class CMIHacpComm extends CMICommand {

	/**
	 * CMIError オブジェクト
	 */
	private CMIError m_LastError = null;
	
	/**
	 * boolean オブジェクト
	 */
	private boolean m_isOpen;
	
	/**
	 * boolean オブジェクト
	 */	
	private boolean m_isExited;
	
	/**	
	 * コンストラクタ<br>
	 * @param cbtObj CMICBT
	 * @param lessonObj CMILesson
	 * @param evaluationDataObj CMIEvaluationData
	 */
	public CMIHacpComm(CMICBT cbtObj, CMILesson lessonObj,
							CMIEvaluationData evaluationDataObj) {
		super(cbtObj,lessonObj,evaluationDataObj);
	}	

	/**
	 * finalize デストラクタ <BR>
	 */
	public void finalize() {
		m_LastError = null;
	}
	
	/**
	 * HACP分析実行<br>
	 * @param request String 要求データ（HACPフォーマット）
	 * @param response StringBuffer 応答データ（HACPフォーマット）
	 * @return String コマンド名
	 */
	public String doAnalysis(String request, StringBuffer response) {
		int intErrCode = HACPError.HACP_ERR_SUCCESSFUL;
//		StringTokenizer strTokenizer = new StringTokenizer(request, "&");
		CMITokenizer strTokenizer = new CMITokenizer(request, "&");
		String strPair = "";
		String strName = "";
		String strValue = "";
		String strCmdName = "";
		String strVersion = "";
		String strSessionID = "";
		String strPassword = "";
		String strAiccData = "";
		StringBuffer strResData = new StringBuffer();	
		
		// 名前・値ペアの取り出し
		while(strTokenizer.hasMoreTokens()) {
			strPair = strTokenizer.nextToken();
//			StringTokenizer pairDivider = new StringTokenizer(strPair,"=");
			CMITokenizer pairDivider = new CMITokenizer(strPair,"=");
			strName = pairDivider.nextToken();
			try {
				strValue = pairDivider.nextToken();
			} catch(NoSuchElementException nse) {
				strValue = "";
			}		
			strName = strName.toUpperCase();
					
			if ("COMMAND".equals(strName)) {
				strCmdName = strValue;
			} else if ("VERSION".equals(strName)) {
				strVersion = strValue;
				if ( strVersion.startsWith("S") == false ) {
					// 送信バージョンがSCORM1.3以外の場合、
					// CMICBTオブジェクトに設定されている
					// AICC規格のバージョンを更新する
					m_Cbt.setVersion(strVersion);
					CMIS13ModelUtil.setScorm13(false);
				}
				else {
					CMIS13ModelUtil.setScorm13(true);
				}
			} else if ("SESSION_ID".equals(strName)) {
				strSessionID = strValue;
			} else if ("AU_PASSWORD".equals(strName)) {
				strPassword = strValue;
			} else if ("AICC_DATA".equals(strName)) {
				strAiccData = strValue;
			} else {
				// error
				intErrCode = HACPError.HACP_ERR_INVALID_COMMAND;
			}
		}
	
		if (intErrCode == HACPError.HACP_ERR_SUCCESSFUL) {
			String decodedData = CMIUtil.urlDecode(strAiccData);
	
			// cmdName を case incensitive にする。			
			strCmdName = strCmdName.toUpperCase();
					
			// コマンドの振り分け
			if ("GETPARAM".equals(strCmdName)) {
				intErrCode = m_Lesson.doGetParam(decodedData, strResData);
			} else if ("GETLMSCOMMENTS".equals(strCmdName)) {
				intErrCode = m_Lesson.doGetLmsComments(decodedData, strResData);
			} else if ("PUTPARAM".equals(strCmdName)) {
				if ( strVersion.startsWith("S") == true ) {
					// 送信バージョンがSCORM1.3の場合
					intErrCode
						= m_Lesson.doPutParamToS13(decodedData, strResData);
					decodedData = strResData.toString();
					strResData.delete(0,strResData.length());
					intErrCode
						= m_EvaluationData.doPutParamToS13(decodedData,
														   strResData);
				}
				else {
					// 送信バージョンが上記以外の場合
					intErrCode
						= m_Lesson.doPutParam(decodedData, strResData);
					intErrCode
						= m_EvaluationData.doPutParam(decodedData,
													  strResData);
				}
			} else if ("PUTCOMMENTS".equals(strCmdName)) {
				if ( strVersion.startsWith("S") == true ) {
					// 送信バージョンがSCORM1.3の場合
					intErrCode = m_EvaluationData.doPutCommentsToS13(
							decodedData, strResData);
				}
				else {
					// 送信バージョンが上記以外の場合
					intErrCode = m_EvaluationData.doPutComments(
							decodedData, strResData);
				}
			} else if ("PUTOBJECTIVES".equals(strCmdName)) {
				intErrCode = m_EvaluationData.doPutObjectives(decodedData,
															  strResData);
			} else if ("PUTINTERACTIONS".equals(strCmdName)) {
				if ( strVersion.startsWith("S") == true ) {
					// 送信バージョンがSCORM1.3の場合
					intErrCode = m_EvaluationData.doPutInteractionsToS13(
							decodedData, strResData);
				}
				else {
					// 送信バージョンが上記以外の場合
					intErrCode = m_EvaluationData.doPutInteractions(
							decodedData, strResData);
				}
			} else if ("PUTPERFORMANCE".equals(strCmdName)) {
				intErrCode = m_EvaluationData.doPutPerformance(decodedData,
																 strResData);
			} else if ("PUTPATH".equals(strCmdName)) {
				intErrCode = m_EvaluationData.doPutPath(decodedData, strResData);
			} else if ("EXITAU".equals(strCmdName)) {
				intErrCode = m_Lesson.doExitAU(strValue, strResData);
			} else {
				// unknown command; protocol error
				intErrCode = HACPError.HACP_ERR_INVALID_COMMAND;
			}
		}
		String strResonse = makeResponse(strResData.toString(), intErrCode);
		response.delete(0,response.length());
		response.append(strResonse);

		// 通信後のフラグ設定を元（SCORM 1.3規格用）に戻す
		CMIS13ModelUtil.setScorm13(true);
		return strCmdName;
	}

	/**
	 * HACPレスポンスの生成<br>
	 * @param data String
	 * @param errorNum int
	 * @return String 応答文字列
	 */
	public String makeResponse(String data, int errorNum) {
		StringBuffer sbRes = new StringBuffer();
		// string encoded_data = urlEncode(data);
		sbRes.append("error=");
		sbRes.append(String.valueOf(errorNum));
		sbRes.append(CMIElement.CHAR_CRLF);
		// error_text
		sbRes.append("error_text=");
		sbRes.append(HACPError.getErrorString(errorNum));
		sbRes.append(CMIElement.CHAR_CRLF);

		if (CMIS13ModelUtil.isScorm13() == true) {
			// クライアントからのSCORM1.3形式での受信要求である場合
			sbRes.append("detail_error=");
			sbRes.append(String.valueOf(m_Cbt.getError()));
			sbRes.append(CMIElement.CHAR_CRLF);

			sbRes.append("version=");
			sbRes.append("S1.3");
			sbRes.append(CMIElement.CHAR_CRLF);
		}
		else {
			// version
				// CMI のVersion を返す。
			// response += string("version=") + string(DEF_CMI_AICC_VERSION) + CHAR_CRLF;
				// CBT のVersion を返す。
			String strCbtVer = m_Cbt.getVersionStr();
			if (strCbtVer == null || "".equals(strCbtVer)) {
				sbRes.append("version=");
				sbRes.append(CMIElement.DEF_CMI_AICC_VERSION);
				sbRes.append(CMIElement.CHAR_CRLF);
			} else {
				sbRes.append("version=");
				sbRes.append(m_Cbt.getVersionStr());
				sbRes.append(CMIElement.CHAR_CRLF);
			}		
		}

		// aicc_data
		sbRes.append("aicc_data=");
		sbRes.append(data);
		sbRes.append(CMIElement.CHAR_CRLF);
		return sbRes.toString();
	}
}
